const mongoose = require('mongoose');

const Payment = new mongoose.Schema({
    token_shop: {
        type: String,
        required: true
    },
    return_shop: {
        type: Object
    },
    callback: {
        type: String,
        required: true
    },
    status: {
        type: String,
        default: 'Not Processed'
    },
    status_delivery: {
        type: String,
        default: 'Not Processed'
    },
    status_pagseguro: {
        type: String,
        default: 'Not Processed'
    },
    reference_id: {
        type: String,
        required: true
    },
    description: {
        type: String,
        required: true
    },
    amount: {
        value: {type: Number, required: true},
        currency: {type: String, required: true}
    },
    payment_method: {
        type: {type: String, required: true},
        installments: {type: Number, required: true},
        capture: {type: Boolean, required: true},
        card: {
            encrypted: {type: String, required: true},
            /*number: {type: String, required: true},
            exp_month: {type: String, required: true},
            exp_year: {type: String, required: true},
            security_code: {type: String, required: true},
            holder: {
                name: {type: String, required: true},
            }*/
        }
    },
    notification_urls: [],
    links:[]
},
{
    timestamps: true,
}
);

mongoose.model('payment', Payment);