const express = require('express');
const mongoose = require('mongoose');
const axios = require('axios').default;
//import {cronPlugin} from 'mongoose-cron';
const cron = require('node-cron');
const bodyParser = require('body-parser');



require("dotenv-safe").config();
var jwt = require('jsonwebtoken');

require('./models/Payment');
const Payment = mongoose.model('payment');

const app = express();

app.use(bodyParser.text());
app.use(function (req, res, next) {
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "*");
    res.header("Access-Control-Allow-Methods", "GET, POST, PUT, DELETE");
    res.header('Access-Control-Allow-Credentials', true);
    res.header('Access-Control-Max-Age', '86400');
    next();
});


mongoose.connect('mongodb://localhost/1900payments', {
  useNewUrlParser: true,
  useUnifiedTopology: true,
  useFindAndModify: false,
  useCreateIndex: true
}).then(() => {
    console.log("Conexão com MongoDB realizada com sucesso!");
}).catch((erro) => {
    console.log("Erro. Conexão não realizada");
});

function verifyJWT(req, res, next){
    var token = req.headers['x-access-token'];
    if (!token) return res.status(401).json({ auth: false, message: 'No token provided.' });
    
    jwt.verify(token, process.env.SECRET, function(err, decoded) {
      if (err) return res.status(500).json({ auth: false, message: 'Failed to authenticate token.' });
      
      req.userId = decoded.id;
      next();
    });
}

//authentication
app.post('/login', (req, res) => {
    console.log('eita');
 
    const bodyParsed = JSON.parse(req.body);
    console.log(JSON.parse(req.body));

    if(bodyParsed.user === '1900' && bodyParsed.pwd === 'KLJDPA&#jd'){
      //auth ok
      const id = 1; //esse id viria do banco de dados
      var token = jwt.sign({ id }, process.env.SECRET, {
        expiresIn: 300000 // expires in 5min
      });
      return res.json({ auth: true, token: token });
    }
    
    res.status(500).json({message: 'Login inválido!'});
});

app.post('/logout', function(req, res) {
    res.json({ auth: false, token: null });
});

 

app.post('/public-key', function(req, res) {

    const bodyParsed = JSON.parse(req.body);
    let hasError = false;
    let public_key_pagseguro;

    const sendGetRequest = async (res) => {
        try {
            const response = await axios.post(process.env.APIPAGSEGURO+'/public-keys', {
                "type": "card"
            },{
                headers:  { Authorization: "Bearer " + bodyParsed.token_shop }
            });
    
            public_key_pagseguro = response.data.public_key;
          

            console.log(public_key_pagseguro);

        } catch (err) {
            console.log('caiu no catch');
            if(err.response.status !== 200 &&  err.response.data.error_messages) {
                console.log('entro');
                hasError = {
                    error: true,
                    message: err.response.data.error_messages[0],
                    details: "Pagseguro: "+err.response.statusText,
                    id:payment._id
                }
                console.log(hasError);
            }
        }

        console.log('resposta jason');
        console.log('temos error');

        if(hasError){
            return res.status(200).json(hasError);
        } else {
         

            if(public_key_pagseguro){
                return res.status(200).json({
                    public_key: public_key_pagseguro,
                });
            } else {
                return res.status(200).json({
                    error: true,
                    message: "Chamada não é válida"
                });
            }
        }

    };
    
    sendGetRequest(res);


    //res.json({ auth: false, token: null });
});

app.get("/payment/:id", verifyJWT,  (req, res) => {
    query = {_id: req.params.id}



    Payment.find(query, function(err, payment){
        //console.log(payment[0].payment_method.card);
      

        return res.status(200).json([{
            amount: payment[0].amount,
            status_delivery: payment[0].status_delivery,
            status_pagseguro: payment[0].status_pagseguro,
            token_shop: payment[0].token_shop,
            return_shop: payment[0].return_shop
        }]);
    });
});


app.post("/payment/:id", bodyParser.json(), (req, res) => {

   // console.log(req.body);

    query = {_id: req.params.id}

    let cancelCallback = req.body.links[1].href;

    console.log(cancelCallback);
    if(!req.body.status){
        //CANCELA TUDO
    }

    Payment.findOneAndUpdate(query, {status_pagseguro:req.body.status}, function(err, payment){
        if (err || !payment) {
            return res.status(404).json({
                error: true,
                message: "Erro: Pagamento não atualizado, reference_id não bate com id do meio de pagamento ou excessão. "
            });
        }

        if(req.body.status == 'DECLINED' || req.body.status == 'CANCELED' ){

        }

        if(req.body.status == 'PAID' ){
            axios.post(payment.callback)
            .then(function (response) {
                query = {_id: payment._id}
                let responseData;

        
                responseData = req.body;
                
                Payment.updateOne(query, {status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                    responseData = response.data;
                });
    
               // console.log(response);

                if(responseData.resultado !== 'OK'){
                    //cancela e estorna o pagamento
   
                    axios.post(cancelCallback,{ headers:  { Authorization: "Bearer " + payment.token_shop }})
                    .then(function (response) {
                        query = {_id: payment._id}
                        let responseData;
        
                
                        responseData = req.body;
                        
                        Payment.updateOne(query, {status_pagseguro:'CANCELLED',status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                            responseData = response.data;
                        });
    
            
                        if (response.status == 200){
            
                            return res.status(200).json( {
                                error: false,
                                message: "Pedido cancelado com sucesso"
                            });
                        }
                        
                        if(response.status !== 200){
                            Payment.updateOne(query, {status_pagseguro:'ERROR_ON_CANCELLED',status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                                responseData = response.data;
                            });

                            return res.status(200).json( {
                                error: false,
                                message: "Houve um erro no pedido"
                            });
            
                            //cancela e estorna o pagamento
                        }
                    })
                    .catch(function (error) {
                        console.log(error);
                    });
                    
                }
    
                if (response.status == 200){
    
                    return res.status(200).json( {
                        error: false,
                        message: "Pedido atualizado com sucesso"
                    });
                }
                
                if(response.status !== 200){
                    return res.status(200).json( {
                        error: false,
                        message: "Houve um erro no pedido"
                    });
    
                    //cancela e estorna o pagamento
                }
            })
            .catch(function (error) {
                console.log(error);
            });
        }
       // return  res.status(200).json(responseData);
    });
});    

app.post("/payment", verifyJWT, (req, res) => {
    const bodyParsed = JSON.parse(req.body);

        const payment =  Payment.create(bodyParsed, (err, payment) => {
            console.log(payment);
            const token_shop = bodyParsed.token_shop;
            const pagseguro_data = bodyParsed;
            let public_key_pagseguro;
            let hasError = false;


            const sendGetRequest = async (res) => {
                try {
                    const response = await axios.post(process.env.APIPAGSEGURO+'/public-keys', {
                        "type": "card"
                    },{
                        headers:  { Authorization: "Bearer " + token_shop }
                    });
            
                    public_key_pagseguro = response.data.public_key;
                    const data = {
                        
                        reference_id: pagseguro_data.reference_id,
                        description: pagseguro_data.description,
                        amount: pagseguro_data.amount,
                        payment_method: pagseguro_data.payment_method,
                        //notification_urls: pagseguro_data.notification_urls
                        notification_urls:[process.env.APIPAGSEGURO+'/payment/'+payment._id]
                          
                    }
    
                    console.log(public_key_pagseguro);

                    const responseCharge = await axios.post(process.env.APIPAGSEGURO+'/charges', JSON.stringify(data),{
                        headers:  { Authorization: "Bearer " + token_shop, "x-api-version":"4.0", "Content-type": "application/json" }
                    });

                  
                    if(responseCharge.data){
                        console.log('caiu no data');
                        console.log(responseCharge.data);
                    }
 

                    query = {_id: payment._id}
                    Payment.updateOne(query, {status_pagseguro:responseCharge.data.status,reference_id:responseCharge.data.id, notification_urls:[process.env.NOTIFICATION_URL+'/'+payment._id], links:responseCharge.data.links }, function(err, res){
                       // console.log(res);
                    });

                    if(responseCharge.data.status == 'AUTHORIZED'){
                        axios.post(payment.callback)
                        .then(function (response) {
                            query = {_id: payment._id}
                            let responseData;
            
                    
                            responseData = req.body;
                            
                            Payment.updateOne(query, {status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                                responseData = response.data;
                            });
                
                           // console.log(response);
            
                            if(responseData.resultado == 'OK'){
                                //cancela e estorna o pagamento
               
                                axios.post(cancelCallback,{ headers:  { Authorization: "Bearer " + payment.token_shop }})
                                .then(function (response) {
                                    query = {_id: payment._id}
                                    let responseData;
                    
                            
                                    responseData = req.body;
                                    
                                    Payment.updateOne(query, {status_pagseguro:'CANCELLED',status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                                        responseData = response.data;
                                    });
                
                        
                                    if (response.status == 200){
                        
                                        return res.status(200).json( {
                                            error: false,
                                            message: "Pedido cancelado com sucesso"
                                        });
                                    }
                                    
                                    if(response.status !== 200){
                                        Payment.updateOne(query, {status_pagseguro:'ERROR_ON_CANCELLED',status_delivery:response.data.resultado,description:response.data.resultado, return_shop:response.data}, function(err, res){
                                            responseData = response.data;
                                        });
            
                                        return res.status(200).json( {
                                            error: false,
                                            message: "Houve um erro no pedido"
                                        });
                        
                                        //cancela e estorna o pagamento
                                    }
                                })
                                .catch(function (error) {
                                    console.log(error);
                                });
                                
                            }
                
                            if (response.status == 200){
                
                                return res.status(200).json( {
                                    error: false,
                                    message: "Pedido atualizado com sucesso"
                                });
                            }
                            
                            if(response.status !== 200){
                                return res.status(200).json( {
                                    error: false,
                                    message: "Houve um erro no pedido"
                                });
                
                                //cancela e estorna o pagamento
                            }
                        })
                        .catch(function (error) {
                            console.log(error);
                        });
                        
                        
                    }

                    

                } catch (err) {
                 
                    if(err.response.status !== 200 &&  err.response.data.error_messages) {
                   
                        hasError = {
                            error: true,
                            message: err.response.data.error_messages[0],
                            details: "Pagseguro: "+err.response.statusText,
                            id:payment._id
                        }

                        query = {_id: payment._id}

                        Payment.updateOne(query, {status_pagseguro:'ERROR', notification_urls:[process.env.NOTIFICATION_URL+'/'+payment._id]}, function(err, res){
                           // console.log(res);
                        });
                     
                    }
                }

                if(hasError){
                    return res.status(200).json(hasError);
                } else {
                 

                    if(payment){
                        return res.status(200).json({
                            error: false,
                            message: "Requisição Pagamento realizado!",
                            id:payment._id
                        });
                    } else {
                        return res.status(200).json({
                            error: true,
                            message: "Faltam parametros para concluir a transação, verifique o schema."
                        });
                    }
                }
        
            };
            
            sendGetRequest(res);

           

        




            /////

            // PEGA PUBLIC KEY DA PAGSEGURO
        //      axios.post(process.env.APIPAGSEGURO+'/public-keys', {
        //         "type": "card"
        //     },{
        //         headers:  { Authorization: "Bearer " + token_shop }
        //     })
        //     .then(function (response) {
  
        //         public_key_pagseguro = response.data.public_key;
        //         const data = {
                    
        //             reference_id: pagseguro_data.reference_id,
        //             description: pagseguro_data.description,
        //             amount: pagseguro_data.amount,
        //             payment_method: pagseguro_data.payment_method,
        //             notification_urls: pagseguro_data.notification_urls
                      
        //         }



        //         console.log(public_key_pagseguro);
                
        //           axios.post(process.env.APIPAGSEGURO+'/charges', data,{
        //             headers:  { Authorization: "Bearer " + token_shop, "x-api-version":"4.0", "Content-type": "application/json" }
        //         })
        //         .then(function (response) {
        //             query = {_id: payment._id}
        //             Payment.updateOne(query, {status:response.data.status,reference_id:response.data.id, notification_urls:[process.env.NOTIFICATION_URL+'/'+payment._id], links:response.data.links }, function(err, res){
        //                // console.log(res);
        //             });

        //             console.log('aqui'+response.status);

                   
                
        //         })
        //         .catch(function (error) {
        //           // console.log(error);
        //            if(error.response.status !== 200) {
        //                console.log('entro');
        //             hasError = {
        //                 error: true,
        //                 message: error.response.data.error_messages[0],
        //                 details: "Pagseguro: "+error.response.statusText,
        //             }
        //             console.log(hasError);
        //         }
                   
        //         });

        //     })
        //     .catch(function (error) {
        //         console.log(hasError);
        //     });

        // if(err) return res.status(400).json({
        //     error: true,
        //     message: "Erro: Pagamento não realizado."
        // });

        // console.log('tem erro');
        // console.log(hasError);

        // if(!hasError){
        //     return res.status(200).json({
        //         error: false,
        //         message: "Requisição Pagamento realizado!",
        //         id:payment._id
        //     })
        // } else {
        //     return res.status(400).json(hasError);
        // }

       

    
    });
});

app.listen(8081, () => {
    console.log("Servidor iniciado na porta 8081: http://localhost:8081");
});

//CRON
// cron.schedule("*/30000 * * * * *", function() {

//     query = {$or: [
//         {status: {$ne: 'PAID'}},
//         {status: {$ne: 'COMPLETED'}},
//         {status: {$ne: 'CANCELLED'}},
//       ]}
//     Payment.find(query, function(err, res){
//         console.log(res);
//         //check if is longer than 30 seg to cancel
//         let date = new Date();
//         let SECONDS_30 = 30*1000;
       

//         res.forEach(function (arrayItem) {
//             let total = new Date()-arrayItem.updatedAt;
//             console.log(total);

//             if(total > SECONDS_30) {

//                 console.log('passou de 30seg, cancelando');
//                 if(arrayItem.links[1].href){
//                     axios.post(arrayItem.links[1].href, arrayItem.amount ,{
//                         headers:  { Authorization: "Bearer " + arrayItem.token_shop, "x-api-version":"4.0", "Content-type": "application/json" }
//                     })
//                     .then(function (response) {
//                         query = {_id: arrayItem._id}
//                         Payment.updateOne(query, {status:'CANCELLED' }, function(err, res){
//                         console.log('PAGAMENTO CANCELADO');
//                         });
                    
//                     })
//                     .catch(function (error) {
//                         console.log('erro no cancelamento, não foi possivel');
//                     });
//                 }
   
//             } else {
//                 console.log('ñ passou de 30seg');
//             }
//         });
       
        


       
    
//     });

//     console.log("cancelled cron");  
// })